"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[59085],{54931:(e,t,i)=>{i.r(t),i.d(t,{assets:()=>r,contentTitle:()=>o,default:()=>l,frontMatter:()=>a,metadata:()=>h,toc:()=>d});var s=i(785893),n=i(511151);const a={title:"Authenticator validation stage"},o=void 0,h={id:"flow/stages/authenticator_validate/index",title:"Authenticator validation stage",description:"This stage validates an already configured Authenticator Device. This device has to be configured using any of the other authenticator stages:",source:"@site/docs/flow/stages/authenticator_validate/index.md",sourceDirName:"flow/stages/authenticator_validate",slug:"/flow/stages/authenticator_validate/",permalink:"/docs/flow/stages/authenticator_validate/",draft:!1,unlisted:!1,editUrl:"https://github.com/goauthentik/authentik/edit/main/website/docs/flow/stages/authenticator_validate/index.md",tags:[],version:"current",frontMatter:{title:"Authenticator validation stage"},sidebar:"docs",previous:{title:"TOTP authenticator setup stage",permalink:"/docs/flow/stages/authenticator_totp/"},next:{title:"WebAuthn authenticator setup stage",permalink:"/docs/flow/stages/authenticator_webauthn/"}},r={},d=[{value:"Options",id:"options",level:3},{value:"Less-frequent validation",id:"less-frequent-validation",level:4},{value:"Passwordless authentication",id:"passwordless-authentication",level:4},{value:"Logging",id:"logging",level:4},{value:"WebAuthn Device type restrictions",id:"webauthn-device-type-restrictions",level:4}];function c(e){const t={a:"a",admonition:"admonition",code:"code",em:"em",h3:"h3",h4:"h4",li:"li",p:"p",pre:"pre",ul:"ul",...(0,n.a)(),...e.components};return(0,s.jsxs)(s.Fragment,{children:[(0,s.jsx)(t.p,{children:"This stage validates an already configured Authenticator Device. This device has to be configured using any of the other authenticator stages:"}),"\n",(0,s.jsxs)(t.ul,{children:["\n",(0,s.jsx)(t.li,{children:(0,s.jsx)(t.a,{href:"../authenticator_duo/",children:"Duo authenticator stage"})}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.a,{href:"../authenticator_sms/",children:"SMS authenticator stage"}),"."]}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.a,{href:"../authenticator_static/",children:"Static authenticator stage"}),"."]}),"\n",(0,s.jsx)(t.li,{children:(0,s.jsx)(t.a,{href:"../authenticator_totp/",children:"TOTP authenticator stage"})}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.a,{href:"../authenticator_webauthn/",children:"WebAuth authenticator stage"}),"."]}),"\n"]}),"\n",(0,s.jsx)(t.p,{children:"You can select which type of device classes are allowed."}),"\n",(0,s.jsxs)(t.p,{children:["Using the ",(0,s.jsx)(t.code,{children:"Not configured action"}),", you can choose what happens when a user does not have any matching devices."]}),"\n",(0,s.jsxs)(t.ul,{children:["\n",(0,s.jsx)(t.li,{children:"Skip: Validation is skipped and the flow continues"}),"\n",(0,s.jsx)(t.li,{children:"Deny: Access is denied, the flow execution ends"}),"\n",(0,s.jsxs)(t.li,{children:["Configure: This option requires a ",(0,s.jsx)(t.em,{children:"Configuration stage"})," to be set. The validation stage will be marked as successful, and the configuration stage will be injected into the flow."]}),"\n"]}),"\n",(0,s.jsxs)(t.p,{children:["By default, authenticator validation is required every time the flow containing this stage is executed. To only change this behavior, set ",(0,s.jsx)(t.em,{children:"Last validation threshold"})," to a non-zero value. (Requires authentik 2022.5)\nKeep in mind that when using Code-based devices (TOTP, Static and SMS), values lower than ",(0,s.jsx)(t.code,{children:"seconds=30"})," cannot be used, as with the way TOTP devices are saved, there is no exact timestamp."]}),"\n",(0,s.jsx)(t.h3,{id:"options",children:"Options"}),"\n",(0,s.jsx)(t.h4,{id:"less-frequent-validation",children:"Less-frequent validation"}),"\n",(0,s.jsx)(t.admonition,{type:"info",children:(0,s.jsx)(t.p,{children:"Requires authentik 2022.5.1"})}),"\n",(0,s.jsxs)(t.p,{children:["You can configure this stage to only ask for MFA validation if the user hasn't authenticated themselves within a defined time period. To configure this, set ",(0,s.jsx)(t.em,{children:"Last validation threshold"})," to any non-zero value. Any of the users devices within the selected classes are checked."]}),"\n",(0,s.jsx)(t.h4,{id:"passwordless-authentication",children:"Passwordless authentication"}),"\n",(0,s.jsx)(t.admonition,{type:"info",children:(0,s.jsx)(t.p,{children:"Requires authentik 2021.12.4"})}),"\n",(0,s.jsx)(t.admonition,{type:"caution",children:(0,s.jsxs)(t.p,{children:["Firefox has some known issues regarding FIDO (see ",(0,s.jsx)(t.a,{href:"https://bugzilla.mozilla.org/show_bug.cgi?id=1530370",children:"https://bugzilla.mozilla.org/show_bug.cgi?id=1530370"}),") and TouchID (see ",(0,s.jsx)(t.a,{href:"https://bugzilla.mozilla.org/show_bug.cgi?id=1536482",children:"https://bugzilla.mozilla.org/show_bug.cgi?id=1536482"}),")"]})}),"\n",(0,s.jsxs)(t.p,{children:["Passwordless authentication currently only supports WebAuthn devices, like security keys and biometrics. For an alternate passwordless setup, see ",(0,s.jsx)(t.a,{href:"/docs/flow/stages/password/#passwordless-login",children:"Password stage"}),", which supports other types."]}),"\n",(0,s.jsxs)(t.p,{children:["To configure passwordless authentication, create a new Flow with the designation set to ",(0,s.jsx)(t.em,{children:"Authentication"}),"."]}),"\n",(0,s.jsxs)(t.p,{children:["As first stage, add an ",(0,s.jsx)(t.em,{children:"Authenticator validation"})," stage, with the WebAuthn device class allowed.\nAfter this stage you can bind any additional verification stages.\nAs final stage, bind a ",(0,s.jsx)(t.em,{children:"User login"})," stage."]}),"\n",(0,s.jsxs)(t.p,{children:["Users can either access this flow directly via its URL, or you can modify any Identification stage's ",(0,s.jsx)(t.em,{children:"Passwordless flow"})," setting to add a direct link to this flow."]}),"\n",(0,s.jsx)(t.h4,{id:"logging",children:"Logging"}),"\n",(0,s.jsxs)(t.p,{children:["Logins which used Passwordless authentication have the ",(0,s.jsx)(t.em,{children:"auth_method"})," context variable set to ",(0,s.jsx)(t.code,{children:"auth_webauthn_pwl"}),", and the device used is saved in the arguments. Example:"]}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{className:"language-json",children:'{\n    "auth_method": "auth_webauthn_pwl",\n    "http_request": {\n        "args": {\n            "query": ""\n        },\n        "path": "/api/v3/flows/executor/test/",\n        "method": "GET"\n    },\n    "auth_method_args": {\n        "device": {\n            "pk": 1,\n            "app": "authentik_stages_authenticator_webauthn",\n            "name": "test device",\n            "model_name": "webauthndevice"\n        }\n    }\n}\n'})}),"\n",(0,s.jsx)(t.h4,{id:"webauthn-device-type-restrictions",children:"WebAuthn Device type restrictions"}),"\n",(0,s.jsx)(t.admonition,{type:"info",children:(0,s.jsx)(t.p,{children:"Requires authentik 2024.4"})}),"\n",(0,s.jsx)(t.p,{children:"Optionally restrict which WebAuthn device types can be used to authenticate."}),"\n",(0,s.jsx)(t.p,{children:"When no restriction is set, all WebAuthn devices a user has registered are allowed."}),"\n",(0,s.jsx)(t.p,{children:"These restrictions only apply to WebAuthn devices created with authentik 2024.4 or later."})]})}function l(e={}){const{wrapper:t}={...(0,n.a)(),...e.components};return t?(0,s.jsx)(t,{...e,children:(0,s.jsx)(c,{...e})}):c(e)}}}]);